
#include <glm/glm.hpp>
#include <glm/gtx/spline.hpp>

namespace moglclass
{

class KeyFrame
{
public:
	glm::vec3 position;
	float time;
	KeyFrame(glm::vec3 position_, float time_) { position = position_; time = time_; }
};

class CatmullRomCurveAnimation
{
public:
	CatmullRomCurveAnimation(void) {};
	CatmullRomCurveAnimation(std::vector<KeyFrame> frames_, bool loop_ = true);
	void setKeyframes(std::vector<KeyFrame> frames_);
	void updatePosition(float elapsedTime_);
	glm::vec3 getPosition() { return position; }
	float getDuration() { return endTime; }
	bool getLoop() { return loop; }
	void reset(void);

protected:
	std::vector<KeyFrame> frames;
	glm::vec3 position;
	bool loop;
	//float elapsedTime;
	float endTime;
	int wrap(int value, int max);
};

}

