#pragma once
//////////////////////////////////////////////////////////////////////
// car.h: interface for the Car class.
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class SimpleCar
{
public:
	SimpleCar();
	~SimpleCar() { std::cout << "~SimpleCar" << std::endl; };
	void init();
    void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
	bool update(float dt);

protected:
	Parallelepiped body;
	Torus wheel[2];
	
	glm::vec3 position;
	float direction; // positive/negative direction
	float angle;// wheel angle

	glm::mat4 bodyTransform;
	glm::mat4 wheelTransform[4];
};

} // moglclass namespace